/*!
@ng-dynamic-forms/ui-material 6.0.0-beta 2018-03-28 22:05 UTC
Copyright (c) 2016-2017, Udo Schöfer http://www.udos86.de

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted, provided that the above
copyright notice and this permission notice appear in all copies.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
*/
(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@ng-dynamic-forms/core'), require('@angular/core'), require('@angular/forms'), require('@angular/material'), require('@angular/common'), require('angular2-text-mask')) :
    typeof define === 'function' && define.amd ? define(['exports', '@ng-dynamic-forms/core', '@angular/core', '@angular/forms', '@angular/material', '@angular/common', 'angular2-text-mask'], factory) :
    (factory((global.ngDF = global.ngDF || {}, global.ngDF.materialUI = {}),global.ngDF.core,global.ng.core,global.ng.forms,global.ng.material,global.ng.common,global['angular2-text-mask']));
}(this, (function (exports,core,core$1,forms,material,common,angular2TextMask) { 'use strict';

    var __extends = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicMaterialFormInputControlComponent = /** @class */ (function (_super) {
        __extends(DynamicMaterialFormInputControlComponent, _super);
        function DynamicMaterialFormInputControlComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            return _this;
        }
        Object.defineProperty(DynamicMaterialFormInputControlComponent.prototype, "characterCount", {
            get: /**
             * @return {?}
             */
            function () {
                return this.matInput ? this.matInput.value.length : null;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicMaterialFormInputControlComponent.prototype, "characterHint", {
            get: /**
             * @return {?}
             */
            function () {
                return this.characterCount + " / " + ((/** @type {?} */ (this.model))).maxLength;
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicMaterialFormInputControlComponent.prototype, "showCharacterHint", {
            get: /**
             * @return {?}
             */
            function () {
                return !!((/** @type {?} */ (this.model)).maxLength && this.characterCount);
            },
            enumerable: true,
            configurable: true
        });
        return DynamicMaterialFormInputControlComponent;
    }(core.DynamicFormControlComponent));

    var __extends$1 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicMaterialCheckboxComponent = /** @class */ (function (_super) {
        __extends$1(DynamicMaterialCheckboxComponent, _super);
        function DynamicMaterialCheckboxComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core$1.EventEmitter();
            _this.change = new core$1.EventEmitter();
            _this.customEvent = new core$1.EventEmitter();
            _this.focus = new core$1.EventEmitter();
            return _this;
        }
        DynamicMaterialCheckboxComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: "dynamic-material-checkbox",
                        template: "<ng-container [formGroup]=\"group\"><mat-checkbox #matCheckbox [checked]=\"model.checked\" [color]=\"model.getAdditional('color', 'accent')\" [disableRipple]=\"model.getAdditional('disableRipple', false)\" [formControlName]=\"model.id\" [id]=\"bindId ? model.id : null\" [indeterminate]=\"model.indeterminate\" [labelPosition]=\"model.labelPosition || 'after'\" [name]=\"model.name\" [ngClass]=\"[getClass('element', 'control'), getClass('grid', 'control')]\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" (indeterminateChange)=\"onCustomEvent($event, 'indeterminateChange')\"><span [ngClass]=\"getClass('element', 'label')\" [innerHTML]=\"model.label\"></span></mat-checkbox></ng-container>",
                        changeDetection: core$1.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicMaterialCheckboxComponent.ctorParameters = function () { return [
            { type: core.DynamicFormLayoutService, },
            { type: core.DynamicFormValidationService, },
        ]; };
        DynamicMaterialCheckboxComponent.propDecorators = {
            "bindId": [{ type: core$1.Input },],
            "group": [{ type: core$1.Input },],
            "layout": [{ type: core$1.Input },],
            "model": [{ type: core$1.Input },],
            "blur": [{ type: core$1.Output },],
            "change": [{ type: core$1.Output },],
            "customEvent": [{ type: core$1.Output },],
            "focus": [{ type: core$1.Output },],
            "matCheckbox": [{ type: core$1.ViewChild, args: ["matCheckbox",] },],
        };
        return DynamicMaterialCheckboxComponent;
    }(core.DynamicFormControlComponent));

    var __extends$2 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicMaterialChipsComponent = /** @class */ (function (_super) {
        __extends$2(DynamicMaterialChipsComponent, _super);
        function DynamicMaterialChipsComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core$1.EventEmitter();
            _this.change = new core$1.EventEmitter();
            _this.customEvent = new core$1.EventEmitter();
            _this.focus = new core$1.EventEmitter();
            return _this;
        }
        Object.defineProperty(DynamicMaterialChipsComponent.prototype, "model", {
            get: /**
             * @return {?}
             */
            function () {
                return this._model;
            },
            set: /**
             * @param {?} model
             * @return {?}
             */
            function (model) {
                this._model = model;
                this._chipList = /** @type {?} */ (model.value) || [];
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicMaterialChipsComponent.prototype, "chipList", {
            get: /**
             * @return {?}
             */
            function () {
                return this._chipList;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} $event
         * @return {?}
         */
        DynamicMaterialChipsComponent.prototype.onChipInputTokenEnd = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            var /** @type {?} */ inputElement = $event.input, /** @type {?} */ inputValue = $event.value.trim();
            if (Array.isArray(this.chipList) && inputValue.length > 0) {
                this.chipList.push(inputValue);
                this.control.patchValue(this.chipList);
            }
            if (inputElement instanceof HTMLInputElement) {
                inputElement.value = "";
            }
        };
        /**
         * @param {?} _chip
         * @param {?} index
         * @return {?}
         */
        DynamicMaterialChipsComponent.prototype.onChipRemoved = /**
         * @param {?} _chip
         * @param {?} index
         * @return {?}
         */
        function (_chip, index) {
            if (Array.isArray(this.chipList)) {
                this.chipList.splice(index, 1);
                this.control.patchValue(this.chipList);
            }
        };
        DynamicMaterialChipsComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: "dynamic-material-chips",
                        template: "<mat-form-field [color]=\"model.getAdditional('color', 'primary')\" [floatLabel]=\"model.getAdditional('floatLabel', 'auto')\" [formGroup]=\"group\" [hideRequiredMarker]=\"model.getAdditional('hideRequiredMarker', false)\" [ngClass]=\"getClass('grid', 'control')\"><mat-chip-list #matChipList [formControlName]=\"model.id\" [id]=\"bindId ? model.id : null\" [multiple]=\"true\"><mat-chip *ngFor=\"let chip of chipList; let index = index\" [selectable]=\"false\" (removed)=\"onChipRemoved(chip, index)\"><span>{{ chip }}</span><mat-icon matChipRemove>cancel</mat-icon></mat-chip><input matInput [placeholder]=\"model.placeholder\" [matChipInputFor]=\"matChipList\" [matChipInputAddOnBlur]=\"true\" [matChipInputSeparatorKeyCodes]=\"[13, 188]\" (matChipInputTokenEnd)=\"onChipInputTokenEnd($event)\"></mat-chip-list></mat-form-field>",
                        changeDetection: core$1.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicMaterialChipsComponent.ctorParameters = function () { return [
            { type: core.DynamicFormLayoutService, },
            { type: core.DynamicFormValidationService, },
        ]; };
        DynamicMaterialChipsComponent.propDecorators = {
            "bindId": [{ type: core$1.Input },],
            "group": [{ type: core$1.Input },],
            "layout": [{ type: core$1.Input },],
            "model": [{ type: core$1.Input },],
            "blur": [{ type: core$1.Output },],
            "change": [{ type: core$1.Output },],
            "customEvent": [{ type: core$1.Output },],
            "focus": [{ type: core$1.Output },],
            "matChipList": [{ type: core$1.ViewChild, args: ["matChipList",] },],
            "matInput": [{ type: core$1.ViewChild, args: [material.MatInput,] },],
        };
        return DynamicMaterialChipsComponent;
    }(core.DynamicFormControlComponent));

    var __extends$3 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicMaterialDatePickerComponent = /** @class */ (function (_super) {
        __extends$3(DynamicMaterialDatePickerComponent, _super);
        function DynamicMaterialDatePickerComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core$1.EventEmitter();
            _this.change = new core$1.EventEmitter();
            _this.customEvent = new core$1.EventEmitter();
            _this.focus = new core$1.EventEmitter();
            return _this;
        }
        DynamicMaterialDatePickerComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: "dynamic-material-datepicker",
                        template: "<mat-form-field [color]=\"model.getAdditional('color', 'primary')\" [floatLabel]=\"model.getAdditional('floatLabel', 'auto')\" [formGroup]=\"group\" [hideRequiredMarker]=\"model.getAdditional('hideRequiredMarker', false)\" [ngClass]=\"getClass('grid', 'control')\"><ng-container *ngIf=\"model.label\" ngProjectAs=\"mat-label\"><mat-label>{{ model.label }}</mat-label></ng-container><span *ngIf=\"model.prefix\" matPrefix [innerHTML]=\"model.prefix\"></span> <input matInput [autofocus]=\"model.autoFocus\" [formControlName]=\"model.id\" [id]=\"bindId ? model.id : null\" [max]=\"model.max\" [matDatepicker]=\"matDatepicker\" [min]=\"model.min\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" (blur)=\"onBlur($event)\" (dateChange)=\"onChange($event)\" (dateInput)=\"onCustomEvent($event, 'dateInput')\" (focus)=\"onFocus($event)\"> <span *ngIf=\"model.suffix\" matSuffix [innerHTML]=\"model.suffix\"></span><mat-hint *ngIf=\"model.hint !== null\" align=\"start\" [innerHTML]=\"model.hint\"></mat-hint><mat-datepicker-toggle matSuffix [for]=\"matDatepicker\"></mat-datepicker-toggle><mat-datepicker #matDatepicker [opened]=\"model.getAdditional('opened', false)\" [startAt]=\"model.focusedDate\" [startView]=\"model.getAdditional('startView', 'month')\" [touchUi]=\"model.getAdditional('touchUi', false)\" (closed)=\"onCustomEvent($event, 'closed')\" (opened)=\"onCustomEvent($event, 'opened')\"></mat-datepicker><ng-container *ngFor=\"let message of errorMessages\" ngProjectAs=\"mat-error\"><mat-error *ngIf=\"showErrorMessages\">{{ message }}</mat-error></ng-container></mat-form-field>",
                        changeDetection: core$1.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicMaterialDatePickerComponent.ctorParameters = function () { return [
            { type: core.DynamicFormLayoutService, },
            { type: core.DynamicFormValidationService, },
        ]; };
        DynamicMaterialDatePickerComponent.propDecorators = {
            "bindId": [{ type: core$1.Input },],
            "group": [{ type: core$1.Input },],
            "layout": [{ type: core$1.Input },],
            "model": [{ type: core$1.Input },],
            "blur": [{ type: core$1.Output },],
            "change": [{ type: core$1.Output },],
            "customEvent": [{ type: core$1.Output },],
            "focus": [{ type: core$1.Output },],
            "matDatePicker": [{ type: core$1.ViewChild, args: ["matDatepicker",] },],
            "matInput": [{ type: core$1.ViewChild, args: [material.MatInput,] },],
        };
        return DynamicMaterialDatePickerComponent;
    }(core.DynamicFormControlComponent));

    var __extends$4 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicMaterialInputComponent = /** @class */ (function (_super) {
        __extends$4(DynamicMaterialInputComponent, _super);
        function DynamicMaterialInputComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core$1.EventEmitter();
            _this.change = new core$1.EventEmitter();
            _this.customEvent = new core$1.EventEmitter();
            _this.focus = new core$1.EventEmitter();
            return _this;
        }
        DynamicMaterialInputComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: "dynamic-material-input",
                        template: "<mat-form-field [color]=\"model.getAdditional('color', 'primary')\" [floatLabel]=\"model.getAdditional('floatLabel', 'auto')\" [formGroup]=\"group\" [hideRequiredMarker]=\"model.getAdditional('hideRequiredMarker', false)\" [ngClass]=\"getClass('grid','control')\" [textMask]=\"{mask: (model.mask || false), showMask: model.mask && !(model.placeholder)}\"><ng-container *ngIf=\"model.label\" ngProjectAs=\"mat-label\"><mat-label>{{ model.label }}</mat-label></ng-container><span *ngIf=\"model.prefix\" matPrefix [innerHTML]=\"model.prefix\"></span> <input matInput [attr.accept]=\"model.accept\" [attr.list]=\"model.listId\" [attr.max]=\"model.max\" [attr.min]=\"model.min\" [attr.multiple]=\"model.multiple\" [attr.step]=\"model.step\" [autocomplete]=\"model.autoComplete\" [autofocus]=\"model.autoFocus\" [formControlName]=\"model.id\" [id]=\"bindId ? model.id : null\" [maxlength]=\"model.maxLength\" [matAutocomplete]=\"matAutocomplete\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [pattern]=\"model.pattern\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [spellcheck]=\"model.spellCheck\" [tabindex]=\"model.tabIndex\" [type]=\"model.inputType\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\"> <span *ngIf=\"model.suffix\" matSuffix [innerHTML]=\"model.suffix\"></span><mat-hint *ngIf=\"model.hint !== null\" align=\"start\" [innerHTML]=\"model.hint\"></mat-hint><mat-hint *ngIf=\"showCharacterHint\" align=\"end\">{{ characterHint }}</mat-hint><ng-container *ngFor=\"let message of errorMessages\" ngProjectAs=\"mat-error\"><mat-error *ngIf=\"showErrorMessages\">{{ message }}</mat-error></ng-container></mat-form-field><mat-autocomplete #matAutocomplete=\"matAutocomplete\" [disableRipple]=\"model.getAdditional('disableRipple', false)\" (optionSelected)=\"onChange($event)\"><mat-option *ngFor=\"let option of model.list\" [value]=\"option\">{{ option }}</mat-option></mat-autocomplete>",
                        changeDetection: core$1.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicMaterialInputComponent.ctorParameters = function () { return [
            { type: core.DynamicFormLayoutService, },
            { type: core.DynamicFormValidationService, },
        ]; };
        DynamicMaterialInputComponent.propDecorators = {
            "bindId": [{ type: core$1.Input },],
            "group": [{ type: core$1.Input },],
            "layout": [{ type: core$1.Input },],
            "model": [{ type: core$1.Input },],
            "blur": [{ type: core$1.Output },],
            "change": [{ type: core$1.Output },],
            "customEvent": [{ type: core$1.Output },],
            "focus": [{ type: core$1.Output },],
            "matAutocomplete": [{ type: core$1.ViewChild, args: ["matAutocomplete",] },],
            "matInput": [{ type: core$1.ViewChild, args: [material.MatInput,] },],
        };
        return DynamicMaterialInputComponent;
    }(DynamicMaterialFormInputControlComponent));

    var __extends$5 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicMaterialRadioGroupComponent = /** @class */ (function (_super) {
        __extends$5(DynamicMaterialRadioGroupComponent, _super);
        function DynamicMaterialRadioGroupComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core$1.EventEmitter();
            _this.change = new core$1.EventEmitter();
            _this.customEvent = new core$1.EventEmitter();
            _this.focus = new core$1.EventEmitter();
            return _this;
        }
        DynamicMaterialRadioGroupComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: "dynamic-material-radio-group",
                        template: "<ng-container [formGroup]=\"group\"><mat-radio-group #matRadioGroup [formControlName]=\"model.id\" [id]=\"bindId ? model.id : null\" [labelPosition]=\"model.getAdditional('labelPosition', 'after')\" [name]=\"model.name\" [ngClass]=\"[getClass('element', 'control'), getClass('grid', 'control')]\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\"><mat-radio-button *ngFor=\"let option of model.options$ | async\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'option')\" [value]=\"option.value\"><span [innerHTML]=\"option.label\"></span></mat-radio-button></mat-radio-group></ng-container>",
                        changeDetection: core$1.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicMaterialRadioGroupComponent.ctorParameters = function () { return [
            { type: core.DynamicFormLayoutService, },
            { type: core.DynamicFormValidationService, },
        ]; };
        DynamicMaterialRadioGroupComponent.propDecorators = {
            "bindId": [{ type: core$1.Input },],
            "group": [{ type: core$1.Input },],
            "layout": [{ type: core$1.Input },],
            "model": [{ type: core$1.Input },],
            "blur": [{ type: core$1.Output },],
            "change": [{ type: core$1.Output },],
            "customEvent": [{ type: core$1.Output },],
            "focus": [{ type: core$1.Output },],
            "matRadioGroup": [{ type: core$1.ViewChild, args: ["matRadioGroup",] },],
        };
        return DynamicMaterialRadioGroupComponent;
    }(core.DynamicFormControlComponent));

    var __extends$6 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicMaterialSelectComponent = /** @class */ (function (_super) {
        __extends$6(DynamicMaterialSelectComponent, _super);
        function DynamicMaterialSelectComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core$1.EventEmitter();
            _this.change = new core$1.EventEmitter();
            _this.customEvent = new core$1.EventEmitter();
            _this.focus = new core$1.EventEmitter();
            return _this;
        }
        DynamicMaterialSelectComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: "dynamic-material-select",
                        template: "<mat-form-field [color]=\"model.getAdditional('color', 'primary')\" [ngClass]=\"getClass('grid', 'control')\" [floatLabel]=\"model.getAdditional('floatLabel', 'auto')\" [formGroup]=\"group\"><ng-container *ngIf=\"model.label\" ngProjectAs=\"mat-label\"><mat-label>{{ model.label }}</mat-label></ng-container><span *ngIf=\"model.prefix\" matPrefix [innerHTML]=\"model.prefix\"></span><mat-select #matSelect [disableRipple]=\"model.getAdditional('disableRipple', false)\" [formControlName]=\"model.id\" [id]=\"bindId ? model.id : null\" [multiple]=\"model.multiple\" [ngClass]=\"getClass('element', 'control')\" [placeholder]=\"model.placeholder\" [required]=\"model.required\" (openedChange)=\"onCustomEvent($event, 'openedChange')\" (selectionChange)=\"onChange($event)\"><mat-option *ngFor=\"let option of model.options$ | async\" [ngClass]=\"getClass('element', 'option')\" [value]=\"option.value\"><span [innerHTML]=\"option.label\"></span></mat-option></mat-select><span *ngIf=\"model.suffix\" matSuffix [innerHTML]=\"model.suffix\"></span><mat-hint *ngIf=\"model.hint !== null\" align=\"start\" [innerHTML]=\"model.hint\"></mat-hint><ng-container *ngFor=\"let message of errorMessages\" ngProjectAs=\"mat-error\"><mat-error *ngIf=\"showErrorMessages\">{{ message }}</mat-error></ng-container></mat-form-field>",
                        changeDetection: core$1.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicMaterialSelectComponent.ctorParameters = function () { return [
            { type: core.DynamicFormLayoutService, },
            { type: core.DynamicFormValidationService, },
        ]; };
        DynamicMaterialSelectComponent.propDecorators = {
            "bindId": [{ type: core$1.Input },],
            "group": [{ type: core$1.Input },],
            "layout": [{ type: core$1.Input },],
            "model": [{ type: core$1.Input },],
            "blur": [{ type: core$1.Output },],
            "change": [{ type: core$1.Output },],
            "customEvent": [{ type: core$1.Output },],
            "focus": [{ type: core$1.Output },],
            "matSelect": [{ type: core$1.ViewChild, args: ["matSelect",] },],
        };
        return DynamicMaterialSelectComponent;
    }(core.DynamicFormControlComponent));

    var __extends$7 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicMaterialSlideToggleComponent = /** @class */ (function (_super) {
        __extends$7(DynamicMaterialSlideToggleComponent, _super);
        function DynamicMaterialSlideToggleComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core$1.EventEmitter();
            _this.change = new core$1.EventEmitter();
            _this.customEvent = new core$1.EventEmitter();
            _this.focus = new core$1.EventEmitter();
            return _this;
        }
        DynamicMaterialSlideToggleComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: "dynamic-material-slide-toggle",
                        template: "<ng-container [formGroup]=\"group\"><mat-slide-toggle #matSlideToggle [checked]=\"model.checked\" [color]=\"model.getAdditional('color', 'accent')\" [disableRipple]=\"model.getAdditional('disableRipple', false)\" [formControlName]=\"model.id\" [id]=\"bindId ? model.id : null\" [labelPosition]=\"model.labelPosition || 'after'\" [name]=\"model.name\" [ngClass]=\"[getClass('element','control'), getClass('grid','control')]\" (change)=\"onChange($event)\"><span *ngIf=\"!model.checked\" [innerHTML]=\"model.offLabel\"></span> <span *ngIf=\"model.checked\" [innerHTML]=\"model.onLabel\"></span></mat-slide-toggle></ng-container>",
                        changeDetection: core$1.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicMaterialSlideToggleComponent.ctorParameters = function () { return [
            { type: core.DynamicFormLayoutService, },
            { type: core.DynamicFormValidationService, },
        ]; };
        DynamicMaterialSlideToggleComponent.propDecorators = {
            "bindId": [{ type: core$1.Input },],
            "group": [{ type: core$1.Input },],
            "layout": [{ type: core$1.Input },],
            "model": [{ type: core$1.Input },],
            "blur": [{ type: core$1.Output },],
            "change": [{ type: core$1.Output },],
            "customEvent": [{ type: core$1.Output },],
            "focus": [{ type: core$1.Output },],
            "matSlideToggle": [{ type: core$1.ViewChild, args: ["matSlideToggle",] },],
        };
        return DynamicMaterialSlideToggleComponent;
    }(core.DynamicFormControlComponent));

    var __extends$8 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicMaterialSliderComponent = /** @class */ (function (_super) {
        __extends$8(DynamicMaterialSliderComponent, _super);
        function DynamicMaterialSliderComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core$1.EventEmitter();
            _this.change = new core$1.EventEmitter();
            _this.customEvent = new core$1.EventEmitter();
            _this.focus = new core$1.EventEmitter();
            return _this;
        }
        DynamicMaterialSliderComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: "dynamic-material-slider",
                        template: "<ng-container [formGroup]=\"group\"><mat-slider #matSlider [color]=\"model.getAdditional('color', 'accent')\" [formControlName]=\"model.id\" [id]=\"bindId ? model.id : null\" [invert]=\"model.getAdditional('invert', false)\" [min]=\"model.min\" [max]=\"model.max\" [ngClass]=\"[getClass('element', 'control'), getClass('grid', 'control')]\" [step]=\"model.step\" [tabIndex]=\"model.tabIndex\" [thumbLabel]=\"model.getAdditional('thumbLabel', true)\" [tickInterval]=\"model.getAdditional('tickInterval', 1)\" [vertical]=\"model.vertical\" (change)=\"onChange($event)\" (input)=\"onCustomEvent($event, 'input')\"></mat-slider></ng-container>",
                        changeDetection: core$1.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicMaterialSliderComponent.ctorParameters = function () { return [
            { type: core.DynamicFormLayoutService, },
            { type: core.DynamicFormValidationService, },
        ]; };
        DynamicMaterialSliderComponent.propDecorators = {
            "bindId": [{ type: core$1.Input },],
            "group": [{ type: core$1.Input },],
            "layout": [{ type: core$1.Input },],
            "model": [{ type: core$1.Input },],
            "blur": [{ type: core$1.Output },],
            "change": [{ type: core$1.Output },],
            "customEvent": [{ type: core$1.Output },],
            "focus": [{ type: core$1.Output },],
            "matSlider": [{ type: core$1.ViewChild, args: ["matSlider",] },],
        };
        return DynamicMaterialSliderComponent;
    }(core.DynamicFormControlComponent));

    var __extends$9 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicMaterialTextAreaComponent = /** @class */ (function (_super) {
        __extends$9(DynamicMaterialTextAreaComponent, _super);
        function DynamicMaterialTextAreaComponent(layoutService, validationService) {
            var _this = _super.call(this, layoutService, validationService) || this;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.blur = new core$1.EventEmitter();
            _this.change = new core$1.EventEmitter();
            _this.customEvent = new core$1.EventEmitter();
            _this.focus = new core$1.EventEmitter();
            return _this;
        }
        DynamicMaterialTextAreaComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: "dynamic-material-textarea",
                        template: "<mat-form-field [color]=\"model.getAdditional('color', 'primary')\" [floatLabel]=\"model.getAdditional('floatLabel', 'auto')\" [formGroup]=\"group\" [hideRequiredMarker]=\"model.getAdditional('hideRequiredMarker', false)\" [ngClass]=\"getClass('grid', 'control')\"><ng-container *ngIf=\"model.label\" ngProjectAs=\"mat-label\"><mat-label>{{ model.label }}</mat-label></ng-container><textarea matInput [cols]=\"model.cols\" [formControlName]=\"model.id\" [id]=\"bindId ? model.id : null\" [maxlength]=\"model.maxLength\" [minlength]=\"model.minLength\" [name]=\"model.name\" [ngClass]=\"getClass('element', 'control')\" [placeholder]=\"model.placeholder\" [readonly]=\"model.readOnly\" [required]=\"model.required\" [rows]=\"model.rows\" [spellcheck]=\"model.spellCheck\" [tabindex]=\"model.tabIndex\" [wrap]=\"model.wrap\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\"></textarea><mat-hint *ngIf=\"model.hint !== null\" align=\"start\" [innerHTML]=\"model.hint\"></mat-hint><mat-hint *ngIf=\"showCharacterHint\" align=\"end\">{{ characterHint }}</mat-hint><ng-container *ngFor=\"let message of errorMessages\" ngProjectAs=\"mat-error\"><mat-error *ngIf=\"showErrorMessages\">{{ message }}</mat-error></ng-container></mat-form-field>",
                        changeDetection: core$1.ChangeDetectionStrategy.OnPush
                    },] },
        ];
        /** @nocollapse */
        DynamicMaterialTextAreaComponent.ctorParameters = function () { return [
            { type: core.DynamicFormLayoutService, },
            { type: core.DynamicFormValidationService, },
        ]; };
        DynamicMaterialTextAreaComponent.propDecorators = {
            "bindId": [{ type: core$1.Input },],
            "group": [{ type: core$1.Input },],
            "layout": [{ type: core$1.Input },],
            "model": [{ type: core$1.Input },],
            "blur": [{ type: core$1.Output },],
            "change": [{ type: core$1.Output },],
            "customEvent": [{ type: core$1.Output },],
            "focus": [{ type: core$1.Output },],
            "matInput": [{ type: core$1.ViewChild, args: [material.MatInput,] },],
        };
        return DynamicMaterialTextAreaComponent;
    }(DynamicMaterialFormInputControlComponent));

    var __extends$10 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicMaterialFormControlContainerComponent = /** @class */ (function (_super) {
        __extends$10(DynamicMaterialFormControlContainerComponent, _super);
        function DynamicMaterialFormControlContainerComponent(componentFactoryResolver, layoutService, validationService) {
            var _this = _super.call(this, componentFactoryResolver, layoutService, validationService) || this;
            _this.componentFactoryResolver = componentFactoryResolver;
            _this.layoutService = layoutService;
            _this.validationService = validationService;
            _this.bindId = true;
            _this.context = null;
            _this.blur = new core$1.EventEmitter();
            _this.change = new core$1.EventEmitter();
            _this.focus = new core$1.EventEmitter();
            _this.customEvent = new core$1.EventEmitter();
            return _this;
        }
        Object.defineProperty(DynamicMaterialFormControlContainerComponent.prototype, "componentType", {
            get: /**
             * @return {?}
             */
            function () {
                return this.layoutService.getCustomComponentType(this.model) || materialUIFormControlMapFn(this.model);
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(DynamicMaterialFormControlContainerComponent.prototype, "hasMatFormField", {
            get: /**
             * @return {?}
             */
            function () {
                var _this = this;
                var /** @type {?} */ matFormFieldTypes = [core.DYNAMIC_FORM_CONTROL_TYPE_DATEPICKER, core.DYNAMIC_FORM_CONTROL_TYPE_INPUT,
                    core.DYNAMIC_FORM_CONTROL_TYPE_SELECT, core.DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA];
                return matFormFieldTypes.some(function (type) { return _this.model.type === type; });
            },
            enumerable: true,
            configurable: true
        });
        DynamicMaterialFormControlContainerComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: "dynamic-material-form-control",
                        template: "<div [formGroup]=\"group\" [ngClass]=\"[getClass('element', 'container'), getClass('grid', 'container')]\"><label *ngIf=\"!hasMatFormField && !isCheckbox && hasLabel\" [for]=\"model.id\" [innerHTML]=\"model.label\" [ngClass]=\"[getClass('element', 'label'), getClass('grid', 'label')]\"></label><ng-container *ngTemplateOutlet=\"templates[0]?.templateRef; context: model\"></ng-container><ng-container #componentViewContainer></ng-container><div *ngIf=\"isFormArray\" [dynamicId]=\"bindId && model.id\" [formArrayName]=\"model.id\" [ngClass]=\"[getClass('element', 'control'), getClass('grid', 'control')]\"><div *ngFor=\"let groupModel of model.groups; let idx = index\" role=\"group\" [formGroupName]=\"idx\" [ngClass]=\"[getClass('element', 'group'), getClass('grid', 'group')]\"><dynamic-material-form-control *ngFor=\"let _model of groupModel.group\" [bindId]=\"false\" [context]=\"groupModel\" [group]=\"control.at(idx)\" [hidden]=\"_model.hidden\" [layout]=\"layout\" [model]=\"_model\" [templates]=\"templateList\" [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model)]\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" (matEvent)=\"onCustomEvent($event)\"></dynamic-material-form-control><ng-container *ngTemplateOutlet=\"templates[2]?.templateRef; context: groupModel\"></ng-container></div></div><div *ngIf=\"isFormGroup\" role=\"group\" [dynamicId]=\"bindId && model.id\" [formGroupName]=\"model.id\" [ngClass]=\"[getClass('element', 'control'), getClass('grid', 'control')]\"><dynamic-material-form-control *ngFor=\"let _model of model.group\" [group]=\"control\" [hidden]=\"_model.hidden\" [layout]=\"layout\" [model]=\"_model\" [templates]=\"templateList\" [ngClass]=\"[getClass('element', 'host', _model), getClass('grid', 'host', _model)]\" (blur)=\"onBlur($event)\" (change)=\"onChange($event)\" (focus)=\"onFocus($event)\" (matEvent)=\"onCustomEvent($event)\"></dynamic-material-form-control></div><ng-container *ngIf=\"!hasMatFormField && showErrorMessages\"><mat-error *ngFor=\"let message of errorMessages\">{{ message }}</mat-error></ng-container><ng-container *ngTemplateOutlet=\"templates[1]?.templateRef; context: model\"></ng-container><ng-content></ng-content></div>"
                    },] },
        ];
        /** @nocollapse */
        DynamicMaterialFormControlContainerComponent.ctorParameters = function () { return [
            { type: core$1.ComponentFactoryResolver, },
            { type: core.DynamicFormLayoutService, },
            { type: core.DynamicFormValidationService, },
        ]; };
        DynamicMaterialFormControlContainerComponent.propDecorators = {
            "contentTemplateList": [{ type: core$1.ContentChildren, args: [core.DynamicTemplateDirective,] },],
            "inputTemplateList": [{ type: core$1.Input, args: ["templates",] },],
            "bindId": [{ type: core$1.Input },],
            "context": [{ type: core$1.Input },],
            "group": [{ type: core$1.Input },],
            "layout": [{ type: core$1.Input },],
            "model": [{ type: core$1.Input },],
            "blur": [{ type: core$1.Output },],
            "change": [{ type: core$1.Output },],
            "focus": [{ type: core$1.Output },],
            "customEvent": [{ type: core$1.Output, args: ["matEvent",] },],
            "componentViewContainerRef": [{ type: core$1.ViewChild, args: ["componentViewContainer", { read: core$1.ViewContainerRef },] },],
        };
        return DynamicMaterialFormControlContainerComponent;
    }(core.DynamicFormControlContainerComponent));
    /**
     * @param {?} model
     * @return {?}
     */
    function materialUIFormControlMapFn(model) {
        switch (model.type) {
            case core.DYNAMIC_FORM_CONTROL_TYPE_CHECKBOX:
                return DynamicMaterialCheckboxComponent;
            case core.DYNAMIC_FORM_CONTROL_TYPE_DATEPICKER:
                return DynamicMaterialDatePickerComponent;
            case core.DYNAMIC_FORM_CONTROL_TYPE_INPUT:
                var /** @type {?} */ inputModel = /** @type {?} */ (model);
                return inputModel.multiple ? DynamicMaterialChipsComponent : DynamicMaterialInputComponent;
            case core.DYNAMIC_FORM_CONTROL_TYPE_RADIO_GROUP:
                return DynamicMaterialRadioGroupComponent;
            case core.DYNAMIC_FORM_CONTROL_TYPE_SELECT:
                return DynamicMaterialSelectComponent;
            case core.DYNAMIC_FORM_CONTROL_TYPE_SLIDER:
                return DynamicMaterialSliderComponent;
            case core.DYNAMIC_FORM_CONTROL_TYPE_SWITCH:
                return DynamicMaterialSlideToggleComponent;
            case core.DYNAMIC_FORM_CONTROL_TYPE_TEXTAREA:
                return DynamicMaterialTextAreaComponent;
            default:
                return null;
        }
    }

    var __extends$11 = (this && this.__extends) || (function () {
        var extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return function (d, b) {
            extendStatics(d, b);
            function __() { this.constructor = d; }
            d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
        };
    })();
    var DynamicMaterialFormComponent = /** @class */ (function (_super) {
        __extends$11(DynamicMaterialFormComponent, _super);
        function DynamicMaterialFormComponent(formService, layoutService) {
            var _this = _super.call(this, formService, layoutService) || this;
            _this.formService = formService;
            _this.layoutService = layoutService;
            _this.blur = new core$1.EventEmitter();
            _this.change = new core$1.EventEmitter();
            _this.focus = new core$1.EventEmitter();
            _this.customEvent = new core$1.EventEmitter();
            return _this;
        }
        DynamicMaterialFormComponent.decorators = [
            { type: core$1.Component, args: [{
                        selector: "dynamic-material-form",
                        template: "<dynamic-material-form-control *ngFor=\"let model of formModel; trackBy: trackByFn\" [group]=\"formGroup\" [hidden]=\"model.hidden\" [layout]=\"formLayout\" [model]=\"model\" [ngClass]=\"[getClass(model, 'element', 'host'), getClass(model, 'grid', 'host')]\" [templates]=\"templates\" (blur)=\"onEvent($event, 'blur')\" (change)=\"onEvent($event, 'change')\" (focus)=\"onEvent($event, 'focus')\" (matEvent)=\"onEvent($event, 'custom')\"></dynamic-material-form-control>"
                    },] },
        ];
        /** @nocollapse */
        DynamicMaterialFormComponent.ctorParameters = function () { return [
            { type: core.DynamicFormService, },
            { type: core.DynamicFormLayoutService, },
        ]; };
        DynamicMaterialFormComponent.propDecorators = {
            "formGroup": [{ type: core$1.Input, args: ["group",] },],
            "formModel": [{ type: core$1.Input, args: ["model",] },],
            "formLayout": [{ type: core$1.Input, args: ["layout",] },],
            "blur": [{ type: core$1.Output },],
            "change": [{ type: core$1.Output },],
            "focus": [{ type: core$1.Output },],
            "customEvent": [{ type: core$1.Output, args: ["matEvent",] },],
            "templates": [{ type: core$1.ContentChildren, args: [core.DynamicTemplateDirective,] },],
            "components": [{ type: core$1.ViewChildren, args: [DynamicMaterialFormControlContainerComponent,] },],
        };
        return DynamicMaterialFormComponent;
    }(core.DynamicFormComponent));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */
    var DynamicFormsMaterialUIModule = /** @class */ (function () {
        function DynamicFormsMaterialUIModule() {
        }
        DynamicFormsMaterialUIModule.decorators = [
            { type: core$1.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.ReactiveFormsModule,
                            material.MatAutocompleteModule,
                            material.MatCheckboxModule,
                            material.MatChipsModule,
                            material.MatDatepickerModule,
                            material.MatIconModule,
                            material.MatInputModule,
                            material.MatRadioModule,
                            material.MatSelectModule,
                            material.MatSliderModule,
                            material.MatSlideToggleModule,
                            angular2TextMask.TextMaskModule,
                            core.DynamicFormsCoreModule
                        ],
                        declarations: [
                            DynamicMaterialCheckboxComponent,
                            DynamicMaterialChipsComponent,
                            DynamicMaterialDatePickerComponent,
                            DynamicMaterialInputComponent,
                            DynamicMaterialRadioGroupComponent,
                            DynamicMaterialSelectComponent,
                            DynamicMaterialSlideToggleComponent,
                            DynamicMaterialSliderComponent,
                            DynamicMaterialTextAreaComponent,
                            DynamicMaterialFormControlContainerComponent,
                            DynamicMaterialFormComponent
                        ],
                        entryComponents: [
                            DynamicMaterialCheckboxComponent,
                            DynamicMaterialChipsComponent,
                            DynamicMaterialDatePickerComponent,
                            DynamicMaterialInputComponent,
                            DynamicMaterialRadioGroupComponent,
                            DynamicMaterialSelectComponent,
                            DynamicMaterialSlideToggleComponent,
                            DynamicMaterialSliderComponent,
                            DynamicMaterialTextAreaComponent
                        ],
                        exports: [
                            core.DynamicFormsCoreModule,
                            DynamicMaterialFormControlContainerComponent,
                            DynamicMaterialFormComponent
                        ]
                    },] },
        ];
        /** @nocollapse */
        DynamicFormsMaterialUIModule.ctorParameters = function () { return []; };
        return DynamicFormsMaterialUIModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes} checked by tsc
     */

    exports.DynamicMaterialFormInputControlComponent = DynamicMaterialFormInputControlComponent;
    exports.DynamicMaterialCheckboxComponent = DynamicMaterialCheckboxComponent;
    exports.DynamicMaterialChipsComponent = DynamicMaterialChipsComponent;
    exports.DynamicMaterialDatePickerComponent = DynamicMaterialDatePickerComponent;
    exports.DynamicMaterialInputComponent = DynamicMaterialInputComponent;
    exports.DynamicMaterialRadioGroupComponent = DynamicMaterialRadioGroupComponent;
    exports.DynamicMaterialSelectComponent = DynamicMaterialSelectComponent;
    exports.DynamicMaterialSlideToggleComponent = DynamicMaterialSlideToggleComponent;
    exports.DynamicMaterialSliderComponent = DynamicMaterialSliderComponent;
    exports.DynamicMaterialTextAreaComponent = DynamicMaterialTextAreaComponent;
    exports.DynamicMaterialFormComponent = DynamicMaterialFormComponent;
    exports.DynamicMaterialFormControlContainerComponent = DynamicMaterialFormControlContainerComponent;
    exports.materialUIFormControlMapFn = materialUIFormControlMapFn;
    exports.DynamicFormsMaterialUIModule = DynamicFormsMaterialUIModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ui-material.umd.js.map
